#!/usr/bin/perl


BEGIN
{
       ($dirprg,my $nameprg) = $0 =~ /(.+)\/(.+)/;
       $dirprg = '.' if (! defined $dirprg);
       unshift(@INC,"$dirprg/../lib/");
}

use strict;
use IO::File;

use ParamParser;
my $O_PARAM;

$O_PARAM = New ParamParser("GETOPTLONG",("infile=s","outfiles=s","slices=s"));
$O_PARAM->SetUsage(my $usage = sub {&Usage();});

my $infile;
if ($O_PARAM->IsDefined('infile'))
{
	$O_PARAM->AssertFileExists('infile');
	$infile=new IO::File($O_PARAM->Get('infile')) || Carp::croak ("ERROR ".$O_PARAM->Get('infile')."\n");
}
else
{
	$infile="STDIN";
}
$O_PARAM->SetUnlessDefined('outfiles','');
my $file=$O_PARAM->Get('outfiles');

my $GTranche;
if ( $O_PARAM->IsDefined('slices'))
{
	$O_PARAM->AssertInteger('slices');
	$GTranche = $O_PARAM->Get('slices');
	if ($GTranche <= 0)
	{
		print STDERR "the slices number $GTranche have to be positive !\n";
		exit;
	} 
}
else
{
	if ( $file =~ /nt/ )
	{
		$GTranche = 10000; # nombre de sequences dans un fichier
	}
	else
	{
		$GTranche = 30000; # nombre de sequences dans un fichier
	}
}

my($cptfile)=1;
# my($tranche) = sprintf("%05d",$cptfile) ;
my $slice=new IO::File (">$file.split.$cptfile") || Carp::croak ("ERROR $file.split.$cptfile\n");
print STDERR "$file.split.$cptfile\n";
my $cpt=0;

while (<$infile>)
{
	chomp;
	if ( /^>/  )
	{
		$cpt++;
		if ( $cpt > $GTranche)
		{
			$cptfile++;
			$slice->close;
			#$tranche = sprintf("%05d",$cptfile);
			print STDERR "$file.split.$cptfile\n";
			$slice=new IO::File(">$file.split.$cptfile") || Carp::croak ("ERROR $file.ncbi.split.$cptfile\n");
			$cpt=1;
		}
	}
	print $slice "$_\n";
}
$slice->close;
$infile->close;

sub Usage
{
print STDOUT <<END;

Usage:
     $0 --infile<file> --outfiles<file> --slices <int>
  
        --infile      : path to the infile file, if not defined the input is STDIN
        --outfiles    : prefixe for the outputs files
        --slices      : number of sequences in a file (>0)
END
}
